/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN  
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *  ޥɥ饤СAT91SAM7Sѡ
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"

/*
 *  ޤεư
 */
void
target_timer_initialize(intptr_t exinf)
{
    CLOCK    cyc = TO_CLOCK(TIC_NUME, TIC_DENO);

    /*
     *  ޴Ϣ
     */
    /* å֥͡ */
    sil_wrw_mem((void*)(TADR_PMC_BASE+TOFF_PMC_PCER), (1<<INTNO_TC0_PID));
    /*  */
    sil_wrw_mem((void*)(TADR_TC_BASE+TOFF_TC_CCR), TC_CLKDIS);
    sil_wrw_mem((void*)(TADR_TC_BASE+TOFF_TC_IDR), 0xFFFFFFFF);
    /* ޾ͤΥå */
    assert(cyc <= MAX_CLOCK);
    /* ͤ򥻥å */
    sil_wrw_mem((void*)(TADR_TC_BASE+TOFF_TC_CMR), TC_CLKS_MCK8);	/* 47,923,200Hz/8=5,990,400Hz */
    sil_wrw_mem((void*)(TADR_TC_BASE+TOFF_TC_CMR), sil_rew_mem((void*)(TADR_TC_BASE+TOFF_TC_CMR)) | TC_WAVESEL10);
    sil_wrw_mem((void*)(TADR_TC_BASE+TOFF_TC_RC), cyc);
    /* ߤΥꥢ  */
    sil_wrw_mem((void*)(TADR_TC_BASE+TOFF_TC_IER), TC_CPCS);
    /* ȥ   */
    sil_wrw_mem((void*)(TADR_TC_BASE+TOFF_TC_CCR), (TC_CLKEN|TC_SWTRG));
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(intptr_t exinf)
{
    /* ڥǥ󥰥ӥåȤ򥯥ꥢ */
    sil_rew_mem((void*)(TADR_TC_BASE+TOFF_TC_SR));
    sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_EOICR), 0);
    /*  */
    sil_wrw_mem((void*)(TADR_TC_BASE+TOFF_TC_CCR), TC_CLKDIS);
    /* Ե*/
    sil_wrw_mem((void*)(TADR_TC_BASE+TOFF_TC_IDR), TC_CPCS);    
}

/*
 *  ޳ߥϥɥ
 */
void
target_timer_handler(void)
{
    sil_rew_mem((void *)(TADR_TC_BASE+TOFF_TC_SR));
    
    i_begin_int(INTNO_TIMER);
    signal_time();                    /* ƥåζ */
    i_end_int(INTNO_TIMER);
}
