#!/usr/bin/env ruby

#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: tecsgen.rb 92 2008-05-26 01:43:38Z okuma-top $
#++

#= tecsgen  : TECS Υͥ졼
#
#Authors::   绳 
#Version::   
#Copyright:: Copyright (C) TOPPERS Project, 2008. All rights reserved.
#License::   TOPPERS 饤󥹤˽

###
class Array
  def show_tree( indent )
    indent.times{ print "  " }
    print( "Array\n" )
    self.each{ |m|
      m.show_tree( indent+1 )
    }
  end
end

#=== RUBY 饤֥ɤ
#
# -L, $RUBYLIB, ƥ(/usr/lib/rub..ʤ) ν˥Ԥ
#
# ץ饰ξ b_fatal = false ꡣե뤬ʤƤ⥨顼ϸ塢³
def require_tecsgen_lib( fname, b_fatal = true )
  b_require = false

  # -L  $RUBYLIB ǻꤵ줿ѥӥƥΥѥ饵
  ($library_path+$LOAD_PATH).each{ |path|
    [ "", "tecslib/" ].each { |lp|
      lib = File.expand_path( path ) + '/' + lp + fname

      if File.exist?( lib ) then
        begin
          require( lib )
        rescue
          STDERR << "Fail to load #{fname}"
        end
        b_require = true
        break
      end
    }
    if b_require then
      break
    end
  }
  if b_require == false then
    # Ĥʤä
    STDERR << "tecsgen: Fail to load #{fname}. Check $RUBYLIB environment variable or -L option\n"
    # tecsgen եξߤ
    if b_fatal then
      STDERR << "tecsgen: Exit because of unrecoverble fatal error\n"
      exit 1
    end
  end
end


###

require 'optparse'
require 'runit/assert.rb'
# include RUNIT::Assert

$arguments = ""
ARGV.each { |a| $arguments += " " + a }

$unopt     = false     # bool:   disable optimizing
$gen       = "gen"     # string: folder path to place generated files
$idx_is_id = false     # bool:   all components are idx_is_id
$unique_id = false     # bool:   assign unique id to each cell (otherwise begin from 1 for each celltype)
$debug     = false     # bool:   tecsgen debug message
$dryrun    = false     # bool:   dryrun mode: syntax is checked, but not generate any files
$show_tree = false     # bool:   show parsing tree
$verbose   = false     # bool:   verbose mode: show some messages
$old_mode  = false     # bool:   use tecs_intNN instead of int_leastNN_t
$yydebug   = false     # bool:   yydebug: parser debug mode (need bnf-deb.tab.rb)
$import_path = [ "." ] # string array : import/import_C path
$library_path = []     # string array : path to dir where tecsgen.rb placed
$define    = [ ]       # string array : define
$ram_initializer = false # bool: generate ram initializer
if ENV['TECSGEN_DEFAULT_RAM'] then
  rom_ram_defalult = "ram"
else
  rom_ram_defalult = "rom"
end
if rom_ram_defalult == "rom" then
  $rom       = true      # bool:   ROM support : generate CB separately
else
  $rom       = false     # bool:   ROM support : generate CB separately
end
$cpp       = "gcc -E -DTECS"
if ENV[ 'TECS_CPP' ]then
  $cpp = ENV[ 'TECS_CPP' ]
end

ARGV.options {|parser|
  parser.banner = "Usage: tecsgen [options] files"
  parser.on('-D', '--define=def', 'define cpp symbol for import_C') { |define|
    $define << define
  }
  parser.on('-I', '--improt-path=path', 'imoprt/import_C path') { |path|
    $import_path << path
  }
  parser.on('-L', '--library-path=path', 'path to dir where tecsgen.rb') { |path|
    $library_path << path
  }
  parser.on('-R', '--RAM-initializer',   'generate RAM initializer' ){
    $ram_initializer = true
  }
  parser.on('-U', '--unoptimize', 'unoptimize') {
    $unopt = true
  }
  parser.on('-c', '--cpp=cpp_cmd', 'C pre-processor command used import_C (default: gcc -E -D TECS -D TECS_CPP), you can also specify by environment variable TECS_CPP' ){
    |arg|
    $cpp = arg
  }
  parser.on('-d', '--dryrun',      'dryrun' ){
    $dryrun = true
  }
  parser.on('-g', '--gen=dir',     'generate dir') { |dir|
    $gen = dir
  }
  parser.on('-i', '--idx_is_id',   'set idx_is_id to all celltypes') {
    $idx_is_id = true
  }
  parser.on('-o', '--old-mode',    'old mode' ){
    $old_mode = true
  }
  parser.on('-r', '--ram',     'RAM only' ){
    $rom = false
  }
  parser.on('-s', '--show-tree',   'show parsing tree' ){
    $show_tree = true
  }
  parser.on('-t', '--generator-debug', 'generator debug' ){
    $debug = true
  }
  parser.on('-u', '--unique-id', 'assign unique id for each cell' ){
    $unique_id = true
  }
  parser.on('-v', '--verbose',     'verbose mode' ){
    $verbose = true
  }
  parser.on('-y', '--yydebug',     'yydebug' ){
    $yydebug = true
  }
  parser.version = #{$version}
  parser.release = nil
  parser.parse!
  if ARGV.empty?
    puts parser.help
    exit 1
  end
}

require_tecsgen_lib 'tecslib/version.rb'
STDERR << "tecsgen  version 0.#{$version}  copyright(c) TOPPERS project, 2008\n"

lib_path = ""
delim = ""
$library_path.each{ |path|
  lib_path = "#{lib_path}#{delim}#{path}"
  delim = ":"
}

unless $yydebug then
  require_tecsgen_lib 'tecslib/bnf.tab.rb'
else
  require_tecsgen_lib 'tecslib/bnf-deb.tab.rb'
end

require_tecsgen_lib 'tecslib/syntaxobj.rb'
require_tecsgen_lib 'tecslib/messages.rb'
require_tecsgen_lib 'tecslib/types.rb'
require_tecsgen_lib 'tecslib/componentobj.rb'
require_tecsgen_lib 'tecslib/expression.rb'
require_tecsgen_lib 'tecslib/generate.rb'
require_tecsgen_lib 'tecslib/optimize.rb'
require_tecsgen_lib 'tecslib/plugin.rb'

# C 
require_tecsgen_lib 'tecslib/C_parser.tab.rb'
require_tecsgen_lib 'tecslib/ctypes.rb'

begin
  if ! File.directory?( $gen ) then
    Dir.mkdir( $gen )
  end
rescue
  print( "Cannot mkdir #{$gen}\n" )
  exit 1
end


root_namespace = Namespace.new("::")
root_region    = Region.new("::RootRegion".to_sym)

ARGV.each{ |f|
   Import.new( f )
}

root_namespace.check_ref_but_undef

msg = nil
if Generator.get_n_error != 0 then
  msg = "#{Generator.get_n_error} error"
  msg = "#{msg}s" if Generator.get_n_error >= 2
end

if Generator.get_n_warning != 0 then
  msg = "#{msg}  " if msg
  msg = "#{msg}#{Generator.get_n_warning} warning"
  msg = "#{msg}s" if Generator.get_n_warning >= 2
end

puts msg if msg

root_namespace.set_cell_id

if Generator.get_n_error == 0 then
  # 顼ȯƤ顢Ŭϼ»ܤʤ
  if ! $unopt then
    root_namespace.optimize
  end
end

if $show_tree then
  # 顼ȯƤƤɽʥ顼ȯϺŬƤʤΤա
  root_namespace.show_tree(0)
end

if Generator.get_n_error != 0 then
  exit 1
end

root_namespace.generate
root_namespace.generate_post

